package cz.fidentis.analyst.curvature;

import cz.fidentis.analyst.core.ControlPanelBuilder;
import java.awt.event.ActionEvent;
import java.util.List;
import javax.swing.ImageIcon;

/**
 * Control panel for curvature analysis.
 * 
 * @author Radek Oslejsek
 */
public class CurvaturePanel extends javax.swing.JPanel {
    
    public static final ImageIcon ICON = new ImageIcon(CurvaturePanel.class.getClassLoader().getResource("/curvature28x28.png"));
    public static final String NAME = "Curvature";
    
    public static final String GAUSSIAN_CURVATURE = "Gaussian";
    public static final String MEAN_CURVATURE = "Mean";
    public static final String MIN_CURVATURE = "Min";
    public static final String MAX_CURVATURE = "Max";
    
    /**
     * Constructor.
     * @param curvAction Action listener
     */
    public CurvaturePanel(CurvatureAction curvAction) {
        ControlPanelBuilder builder = new ControlPanelBuilder(this);
        
        builder.addCaptionLine("Visualization options:");
        builder.addLine();
        
        builder.addCheckBoxOptionLine(null, "Show curvature", false,
                (ActionEvent e) -> {
                    curvAction.actionPerformed(new ActionEvent(
                            e.getSource(), 
                            ActionEvent.ACTION_PERFORMED, 
                            CurvatureAction.ACTION_COMMAND_SHOW_HIDE_HEATMAP)
                    ); 
                });
        builder.addComboBox(List.of(GAUSSIAN_CURVATURE, MEAN_CURVATURE, MIN_CURVATURE, MAX_CURVATURE), 
                (ActionEvent e) -> {                    
                    curvAction.actionPerformed(new ActionEvent(
                            e.getSource(), 
                            ActionEvent.ACTION_PERFORMED, 
                            CurvatureAction.ACTION_COMMAND_SET_CURVATURE_TYPE)
                    ); 
                });
        builder.addGap();
        builder.addLine();
        builder.addVerticalStrut();
    }
    
}
