package cz.fidentis.analyst.distance;

import cz.fidentis.analyst.core.ControlPanelBuilder;
import java.awt.event.ActionEvent;
import java.util.List;
import javax.swing.ImageIcon;

/**
 * Control panel for Hausdorff distance.https://www.google.com/#
 * 
 * @author Radek Oslejsek
 */
public class DistancePanel extends javax.swing.JPanel {
    
    public static final ImageIcon ICON = new ImageIcon(DistancePanel.class.getClassLoader().getResource("/distance28x28.png"));
    public static final String NAME = "Hausdorff distance";
    
    public static final String  STRATEGY_POINT_TO_POINT= "Point to point";
    public static final String  STRATEGY_POINT_TO_TRIANGLE= "Point to triangle";
    
    /**
     * Constructor.
     * @param action Action listener
     */
    public DistancePanel(DistanceAction action) {
        ControlPanelBuilder builder = new ControlPanelBuilder(this);
        
        builder.addCaptionLine("Computation options:");
        builder.addLine();
        
        builder.addCheckBoxOptionLine(null, "Relative distance", false,
                (ActionEvent e) -> {
                    action.actionPerformed(new ActionEvent(
                            e.getSource(), 
                            ActionEvent.ACTION_PERFORMED, 
                            DistanceAction.ACTION_COMMAND_RELATIVE_ABSOLUTE_DIST)
                    ); 
                });
        builder.addLine();
        
        builder.addOptionText("Distance strategy");
        builder.addComboBox(List.of(STRATEGY_POINT_TO_POINT, STRATEGY_POINT_TO_TRIANGLE),
                (ActionEvent e) -> {                    
                    action.actionPerformed(new ActionEvent(
                            e.getSource(), 
                            ActionEvent.ACTION_PERFORMED, 
                            DistanceAction.ACTION_COMMAND_SET_DISTANCE_STRATEGY)
                    ); 
                });
        builder.addGap();
        builder.addLine();
        
        builder.addCaptionLine("Visualization options:");
        builder.addLine();
        builder.addCheckBoxOptionLine(null, "Show Hausdorff distance", false,
                (ActionEvent e) -> {
                    action.actionPerformed(new ActionEvent(
                            e.getSource(), 
                            ActionEvent.ACTION_PERFORMED, 
                            DistanceAction.ACTION_COMMAND_SHOW_HIDE_HEATMAP)
                    ); 
                });
        builder.addLine();
        builder.addVerticalStrut();
    }
    
}
