package cz.fidentis.analyst.toolbar;

import cz.fidentis.analyst.canvas.Canvas;
import cz.fidentis.analyst.distance.DistanceAction;
import cz.fidentis.analyst.distance.DistancePanel;
import javax.swing.JTabbedPane;
import javax.swing.JToggleButton;
import org.openide.util.NbBundle;

/**
 * A toolbar extension for the analysis of two faces.
 * 
 * @author Radek Oslejsek
 */
public class FaceToFaceToolBar extends RenderingToolBar {
    
    /**
     * Constructor.
     * 
     * @param canvas Rendering canvas
     * @param controlPanel The top component control panels
     */
    public FaceToFaceToolBar(Canvas canvas, JTabbedPane controlPanel) {
        super(canvas);
        addPrimaryFaceButton();
        addSecondaryFaceButton();
        addSeparator();
        addDistanceButton(controlPanel);
    }
    
    private void addDistanceButton(JTabbedPane controlPanel) {
        JToggleButton button = new JToggleButton();
        button.addActionListener(new DistanceAction(controlPanel, getCanvas()));
        button.setActionCommand(DistanceAction.ACTION_COMMAND_SHOW_HIDE_PANEL);
        button.setIcon(DistancePanel.ICON);
        button.setToolTipText(NbBundle.getMessage(RenderingToolBar.class, "FaceToFaceToolBar.curvature.text"));
        add(button);
    }
    
}
